// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from r2r_spl_test_interfaces:msg/NestedTypes.idl
// generated code does not contain a copyright notice

#ifndef R2R_SPL_TEST_INTERFACES__MSG__DETAIL__NESTED_TYPES__TRAITS_HPP_
#define R2R_SPL_TEST_INTERFACES__MSG__DETAIL__NESTED_TYPES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "r2r_spl_test_interfaces/msg/detail/nested_types__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'data_basic_types'
// Member 'data_basic_types_array'
#include "r2r_spl_test_interfaces/msg/detail/basic_types__traits.hpp"

namespace r2r_spl_test_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const NestedTypes & msg,
  std::ostream & out)
{
  out << "{";
  // member: data_basic_types
  {
    out << "data_basic_types: ";
    to_flow_style_yaml(msg.data_basic_types, out);
    out << ", ";
  }

  // member: data_basic_types_array
  {
    if (msg.data_basic_types_array.size() == 0) {
      out << "data_basic_types_array: []";
    } else {
      out << "data_basic_types_array: [";
      size_t pending_items = msg.data_basic_types_array.size();
      for (auto item : msg.data_basic_types_array) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const NestedTypes & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: data_basic_types
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_basic_types:\n";
    to_block_style_yaml(msg.data_basic_types, out, indentation + 2);
  }

  // member: data_basic_types_array
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data_basic_types_array.size() == 0) {
      out << "data_basic_types_array: []\n";
    } else {
      out << "data_basic_types_array:\n";
      for (auto item : msg.data_basic_types_array) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const NestedTypes & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace r2r_spl_test_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use r2r_spl_test_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const r2r_spl_test_interfaces::msg::NestedTypes & msg,
  std::ostream & out, size_t indentation = 0)
{
  r2r_spl_test_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use r2r_spl_test_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const r2r_spl_test_interfaces::msg::NestedTypes & msg)
{
  return r2r_spl_test_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<r2r_spl_test_interfaces::msg::NestedTypes>()
{
  return "r2r_spl_test_interfaces::msg::NestedTypes";
}

template<>
inline const char * name<r2r_spl_test_interfaces::msg::NestedTypes>()
{
  return "r2r_spl_test_interfaces/msg/NestedTypes";
}

template<>
struct has_fixed_size<r2r_spl_test_interfaces::msg::NestedTypes>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<r2r_spl_test_interfaces::msg::NestedTypes>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<r2r_spl_test_interfaces::msg::NestedTypes>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // R2R_SPL_TEST_INTERFACES__MSG__DETAIL__NESTED_TYPES__TRAITS_HPP_
